<?php

class CSSReg {

	private  $appID = '';
	private  $debug = array();
	private  $parseTree = '';
	private  $urlValue = '';
	private  $url = '';
	private  $colon = '';
	private  $selectorStart = '';
	private  $selectorEnd = '';
	private  $units = '';
	private  $colourValues = '';
	private  $colours = '';
	private  $decoration = '';
	private  $alignment = '';
	private  $sizes = '';
	private  $fontValues = '';
	private  $font = '';
	private  $backgroundValues = '';
	private  $background = '';
	private  $transform = '';
	private  $borderValues = '';
	private  $border = '';
	private  $listValues = '';
	private  $list = '';
	private  $tableLayout = '';
	private  $whiteSpace = '';
	private  $whiteSpaceValues = '';
	private  $captionSideValues = '';
	private  $captionSide = '';
	private  $mainRegExp = '';
	private  $selectorOpen;
	private  $output;
	private  $disablePositioning=true;
	const ARGUMENT_COUNT = 15;

	private  $charToEntity = array();
	private  $entityToCode = array(
				'apos'=>'&#x0027;','quot'=>'&#x0022;','amp'=>'&#x0026;','lt'=>'&#x003C;','gt'=>'&#x003E;','nbsp'=>'&#x00A0;','iexcl'=>'&#x00A1;','cent'=>'&#x00A2;','pound'=>'&#x00A3;','
				curren'=>'&#x00A4;','yen'=>'&#x00A5;','brvbar'=>'&#x00A6;','sect'=>'&#x00A7;','uml'=>'&#x00A8;','copy'=>'&#x00A9;','ordf'=>'&#x00AA;','laquo'=>'&#x00AB;','
				not'=>'&#x00AC;','shy'=>'&#x00AD;','reg'=>'&#x00AE;','macr'=>'&#x00AF;','deg'=>'&#x00B0;','plusmn'=>'&#x00B1;','sup2'=>'&#x00B2;','sup3'=>'&#x00B3;','
				acute'=>'&#x00B4;','micro'=>'&#x00B5;','para'=>'&#x00B6;','middot'=>'&#x00B7;','cedil'=>'&#x00B8;','sup1'=>'&#x00B9;','ordm'=>'&#x00BA;','raquo'=>'&#x00BB;','
				frac14'=>'&#x00BC;','frac12'=>'&#x00BD;','frac34'=>'&#x00BE;','iquest'=>'&#x00BF;','Agrave'=>'&#x00C0;','Aacute'=>'&#x00C1;','Acirc'=>'&#x00C2;','Atilde'=>'&#x00C3;','
				Auml'=>'&#x00C4;','Aring'=>'&#x00C5;','AElig'=>'&#x00C6;','Ccedil'=>'&#x00C7;','Egrave'=>'&#x00C8;','Eacute'=>'&#x00C9;','Ecirc'=>'&#x00CA;','Euml'=>'&#x00CB;','
				Igrave'=>'&#x00CC;','Iacute'=>'&#x00CD;','Icirc'=>'&#x00CE;','Iuml'=>'&#x00CF;','ETH'=>'&#x00D0;','Ntilde'=>'&#x00D1;','Ograve'=>'&#x00D2;','Oacute'=>'&#x00D3;','
				Ocirc'=>'&#x00D4;','Otilde'=>'&#x00D5;','Ouml'=>'&#x00D6;','times'=>'&#x00D7;','Oslash'=>'&#x00D8;','Ugrave'=>'&#x00D9;','Uacute'=>'&#x00DA;','Ucirc'=>'&#x00DB;','
				Uuml'=>'&#x00DC;','Yacute'=>'&#x00DD;','THORN'=>'&#x00DE;','szlig'=>'&#x00DF;','agrave'=>'&#x00E0;','aacute'=>'&#x00E1;','acirc'=>'&#x00E2;','atilde'=>'&#x00E3;','
				auml'=>'&#x00E4;','aring'=>'&#x00E5;','aelig'=>'&#x00E6;','ccedil'=>'&#x00E7;','egrave'=>'&#x00E8;','eacute'=>'&#x00E9;','ecirc'=>'&#x00EA;','euml'=>'&#x00EB;','
				igrave'=>'&#x00EC;','iacute'=>'&#x00ED;','icirc'=>'&#x00EE;','iuml'=>'&#x00EF;','eth'=>'&#x00F0;','ntilde'=>'&#x00F1;','ograve'=>'&#x00F2;','oacute'=>'&#x00F3;','
				ocirc'=>'&#x00F4;','otilde'=>'&#x00F5;','ouml'=>'&#x00F6;','divide'=>'&#x00F7;','oslash'=>'&#x00F8;','ugrave'=>'&#x00F9;','uacute'=>'&#x00FA;','ucirc'=>'&#x00FB;','
				uuml'=>'&#x00FC;','yacute'=>'&#x00FD;','thorn'=>'&#x00FE;','yuml'=>'&#x00FF;','OElig'=>'&#x0152;','oelig'=>'&#x0153;','Scaron'=>'&#x0160;','scaron'=>'&#x0161;','
				Yuml'=>'&#x0178;','fnof'=>'&#x0192;','circ'=>'&#x02C6;','tilde'=>'&#x02DC;','Alpha'=>'&#x0391;','Beta'=>'&#x0392;','Gamma'=>'&#x0393;','Delta'=>'&#x0394;','
				Epsilon'=>'&#x0395;','Zeta'=>'&#x0396;','Eta'=>'&#x0397;','Theta'=>'&#x0398;','Iota'=>'&#x0399;','Kappa'=>'&#x039A;','Lambda'=>'&#x039B;','Mu'=>'&#x039C;','
				Nu'=>'&#x039D;','Xi'=>'&#x039E;','Omicron'=>'&#x039F;','Pi'=>'&#x03A0;','Rho'=>'&#x03A1;','Sigma'=>'&#x03A3;','Tau'=>'&#x03A4;','Upsilon'=>'&#x03A5;','
				Phi'=>'&#x03A6;','Chi'=>'&#x03A7;','Psi'=>'&#x03A8;','Omega'=>'&#x03A9;','alpha'=>'&#x03B1;','beta'=>'&#x03B2;','gamma'=>'&#x03B3;','delta'=>'&#x03B4;','
				epsilon'=>'&#x03B5;','zeta'=>'&#x03B6;','eta'=>'&#x03B7;','theta'=>'&#x03B8;','iota'=>'&#x03B9;','kappa'=>'&#x03BA;','lambda'=>'&#x03BB;','mu'=>'&#x03BC;','
				nu'=>'&#x03BD;','xi'=>'&#x03BE;','omicron'=>'&#x03BF;','pi'=>'&#x03C0;','rho'=>'&#x03C1;','sigmaf'=>'&#x03C2;','sigma'=>'&#x03C3;','tau'=>'&#x03C4;','
				upsilon'=>'&#x03C5;','phi'=>'&#x03C6;','chi'=>'&#x03C7;','psi'=>'&#x03C8;','omega'=>'&#x03C9;','thetasym'=>'&#x03D1;','upsih'=>'&#x03D2;','piv'=>'&#x03D6;','
				ensp'=>'&#x2002;','emsp'=>'&#x2003;','thinsp'=>'&#x2009;','zwnj'=>'&#x200C;','zwj'=>'&#x200D;','lrm'=>'&#x200E;','rlm'=>'&#x200F;','ndash'=>'&#x2013;','
				mdash'=>'&#x2014;','lsquo'=>'&#x2018;','rsquo'=>'&#x2019;','sbquo'=>'&#x201A;','ldquo'=>'&#x201C;','rdquo'=>'&#x201D;','bdquo'=>'&#x201E;','dagger'=>'&#x2020;','
				Dagger'=>'&#x2021;','bull'=>'&#x2022;','hellip'=>'&#x2026;','permil'=>'&#x2030;','prime'=>'&#x2032;','Prime'=>'&#x2033;','lsaquo'=>'&#x2039;','rsaquo'=>'&#x203A;','
				oline'=>'&#x203E;','frasl'=>'&#x2044;','euro'=>'&#x20AC;','image'=>'&#x2111;','weierp'=>'&#x2118;','real'=>'&#x211C;','trade'=>'&#x2122;','alefsym'=>'&#x2135;','
				larr'=>'&#x2190;','uarr'=>'&#x2191;','rarr'=>'&#x2192;','darr'=>'&#x2193;','harr'=>'&#x2194;','crarr'=>'&#x21B5;','lArr'=>'&#x21D0;','uArr'=>'&#x21D1;','
				rArr'=>'&#x21D2;','dArr'=>'&#x21D3;','hArr'=>'&#x21D4;','forall'=>'&#x2200;','part'=>'&#x2202;','exist'=>'&#x2203;','empty'=>'&#x2205;','nabla'=>'&#x2207;','
				isin'=>'&#x2208;','notin'=>'&#x2209;','ni'=>'&#x220B;','prod'=>'&#x220F;','sum'=>'&#x2211;','minus'=>'&#x2212;','lowast'=>'&#x2217;','radic'=>'&#x221A;','
				prop'=>'&#x221D;','infin'=>'&#x221E;','ang'=>'&#x2220;','and'=>'&#x2227;','or'=>'&#x2228;','cap'=>'&#x2229;','cup'=>'&#x222A;','int'=>'&#x222B;','
				there4'=>'&#x2234;','sim'=>'&#x223C;','cong'=>'&#x2245;','asymp'=>'&#x2248;','ne'=>'&#x2260;','equiv'=>'&#x2261;','le'=>'&#x2264;','ge'=>'&#x2265;','
				sub'=>'&#x2282;','sup'=>'&#x2283;','nsub'=>'&#x2284;','sube'=>'&#x2286;','supe'=>'&#x2287;','oplus'=>'&#x2295;','otimes'=>'&#x2297;','perp'=>'&#x22A5;','
				sdot'=>'&#x22C5;','lceil'=>'&#x2308;','rceil'=>'&#x2309;','lfloor'=>'&#x230A;','rfloor'=>'&#x230B;','lang'=>'&#x2329;','rang'=>'&#x232A;','loz'=>'&#x25CA;','
				spades'=>'&#x2660;','clubs'=>'&#x2663;','hearts'=>'&#x2665;','diams'=>'&#x2666;',
				);
	

	public function __construct($appID=null,$disablePositioning=true) {

		$this->appID = $appID;
		$this->disablePositioning = $disablePositioning;
		$this->initialiseRegex();
	}
	
	public function parse($css) {
		preg_replace_callback($this->mainRegExp,array($this,'cleanup'),$css);
	}
	
	public function setAppID($id) {
		$this->appID = $id;
	}
	
	public function getCSS() {
		return $this->output;
	}
	
	public function getParseTree() {
		return $this->parseTree;
	}
	
	private function cleanup($args) {
	
		/* list usage generate notices on empty array offsets.
		 * for a better error handling, we set all nonexisting offsets to null
		*/
		for ($i = 0; $i < CSSReg::ARGUMENT_COUNT; ++$i) {
			if (!isset($args[$i])) $args[$i] = null; 
		}
		list($zero,$selectorStart,$selectorEnd,$border,$colour,$sizes,$font,$decoration,$alignment,$background,$transform,$list,$tableLayout,$whiteSpace,$captionSide) = $args;
		
		if ($colour !== null && mb_strlen($colour) > 0) {
			$this->parseTree .= 'colour('.$colour.")\n";
			$this->output .= $colour . ";\n";
		}else if ($selectorStart !== null && mb_strlen($selectorStart) > 0 ) {
		
			$this->parseTree .= 'selectorStart('.$selectorStart.")\n";
			$this->selectorOpen = true;
			
			$selectorStart = preg_replace('/{/u','',$selectorStart,1);
			$selectorStart = mb_split(',',$selectorStart);
			if ($this->appID !== null) {
				for ($i=0; $i < count($selectorStart); ++$i) {
					$selectorStart[$i] = preg_replace('/#(\w+)/su','#'.$this->appID.'_$1_',$selectorStart[$i], 1);
					$selectorStart[$i] = preg_replace('/\.(\w+)/su','.'.$this->appID.'_$1_',$selectorStart[$i], 1);
					$selectorStart[$i] = '#'.$this->appID.' '.$selectorStart[$i];
				}
			}
			$this->output .= implode(", ",$selectorStart)."{ \n";
		}else if ($selectorEnd !== null && mb_strlen($selectorEnd) > 0 ) {
			if ($this->selectorOpen) {
				$this->parseTree .= 'selectorEnd('.$selectorEnd.")\n";
				$this->selectorOpen = false;
				$this->output .= "\n" . $selectorEnd . "\n";
			}
		}else if ($sizes !== null && mb_strlen($sizes) > 0 ) {
			if ($this->disablePositioning) {
				return '';
			}
			$this->parseTree .= 'sizes('.$sizes.")\n";
			$this->output .= $sizes . ";\n";
		}else if ($font !== null && mb_strlen($font) >  0 ) {
			$this->parseTree .= 'font('.$font.")\n";
			$font = preg_replace('/"/u',"'",$font);
			$this->output .= $font . ";\n";
		}else if ($transform !== null && mb_strlen($transform) > 0 ) {
			$this->parseTree .= 'transform('.$transform.")\n";
			$this->output .= $transform . ";\n";
		}else if ($decoration !== null && mb_strlen($decoration) > 0 ) {
			$this->parseTree .= 'decoration('.$decoration.")\n";
			$this->output .= $decoration . ";\n";
		}else if ($alignment !== null && mb_strlen($alignment) > 0 ) {
			if ($this->disablePositioning) {
				return '';
			}			
			$this->parseTree .= 'alignment('.$alignment.")\n";
			$this->output .= $alignment . ";\n";
		}else if ($border !== null && mb_strlen($border) > 0 ) {
			$this->parseTree .= 'border('.$border.")\n";
			$this->output .= $border . ";\n";
		}else if ($background !== null && mb_strlen($background) > 0 ) {
			$this->parseTree .= 'background('.$background.")\n";
			$background = $this->parseURL($background);
			$this->output .= $background . ";\n";
		}else if ($list !== null && mb_strlen($list) > 0 ) {
			$this->parseTree .= 'list('.$list.")\n";
			$list = $this->parseURL($list);
			$this->output .= $list . ";\n";
		}else if ($tableLayout !== null && mb_strlen($tableLayout) > 0 ) {
			$this->parseTree .= 'tableLayout('.$tableLayout.")\n";
			$this->output .= $tableLayout . ";\n";
		}else if ($whiteSpace !== null && mb_strlen($whiteSpace) > 0 ) {
			$this->parseTree .= 'whiteSpace('.$whiteSpace.")\n";
			$this->output .= $whiteSpace . ";\n";
		}else if ($captionSide !== null && mb_strlen($captionSide) > 0 ) {
			$this->parseTree .= 'captionSide('.$captionSide.")\n";
			$this->output .= $captionSide . ";\n";
		}
	}
	
	private function parseURL($url) {
		foreach ($this->entityToCode as $name => $code) {
			$this->charToEntity[html_entity_decode($code, ENT_QUOTES, 'UTF-8')] = $name;
		}
		
		return preg_replace_callback('/url[(]([^)]+)[)]/u',array($this,'parseURLCallback1'),$url);
	}
	
	private function parseURLCallback1($url) {
		$url = $url[1];
		$url = preg_replace('/^[\'"]|[\'"]$/','',$url);
		// I've also excluded the colon, because background url's are broken for example "http\3a //..."
		$url = preg_replace_callback('/&[a-z]{1,10};|&#x[a-f0-9]{1,3};|&#\d{1,3};|[^\w\/.: -]/iu',array($this,'parseURLCallback2'),$url);
		return "url('" . $url . "')";
	}
	
	
	private function parseURLCallback2($c) {
		$c = $c[0];
		if (mb_strlen($c) > 1 ) {
			if (mb_strstr($c,"&#x") === 0) {
				$c = preg_replace('/[&#x;]/','',$c);
				$c = intval($c,16);
				return '\\'.dechex($c).' ';
			}else if (preg_match('/^&[a-z]/i',$c)) {
				$c = self::unescapeEntities($c);
				return '\\'.dechex(ord($c)).' ';
			}else {
				$c = preg_replace('/[&#;]/','',$c);
				$c = intval($c,10);
				return '\\'.dechex($c).' ';
			}
			
		}
		return '\\'.dechex(ord($c)).'';
	}
	
	private function unescapeEntities($entity) {
		preg_match('/&(.+?);/',$entity,$matches);
		if (isset($matches[1]) && is_string($matches[1]) ) {
			$entity = $matches[1];
			if ( isset($this->entityToCode[$entity]) ) return html_entity_decode($this->entityToCode[$entity],ENT_QUOTES,'UTF-8');
			if ( mb_strlen($entity) > 2 && $entity{1} == 'x') {
				return intval(mb_substr($entity,2),16);
			}
			return intval(mb_substr($entity,1));
		}
		
		return 0;
	}
	

	private function initialiseRegex() {
		$this->urlValue = '(?:http:\/{2}|\/)(?:[^)]+)';
		$this->url = '(?:url[(](?:'.$this->urlValue.'|["]'.$this->urlValue.'["]|[\']'.$this->urlValue.'[\'])[)])';
		$this->colon = '\s*:\s*';
		$this->selectorStart = '((?:(?:[.#]\w{1,20}|form|optgroup|button|legend|fieldset|label|option|select|textarea|input|audio|aside|article|a|abbr|acronym|address|area|b|bdo|big|br|canvas|caption|center|cite|code|col|dd|del|dfn|dir|div|dl|dt|em|font|h[1-6]|hr|i|img|ins|kbd|li|map|ol|p|pre|q|s|samp|small|span|strike|strong|sub|sup|table|tbody|td|tfoot|th|thead|tr|tt|u|ul|blockquote|image|video|xmp|[*])(?:[:](?:visited|link|hover|active|focus))?\s*[,]?\s*){1,10}[{])';
		$this->selectorEnd = '([}])';
		$this->units = '(?:(?:normal|auto|(?:[+-]?[\/.\d]{1,8}\s*(?:px|%|pt|pc|em|mm|ex|in|cm|\s*)\s*){1,4}))';
		$this->colourValues = '(?:(?:transparent|aqua|black|blue|fuchsia|gray|grey|green|lime|maroon|navy|olive|purple|red|silver|teal|white|yellow)|(?:rgb\(\s*\d{1,3}%?\s*,\s*\d{1,3}%?\s*,\s*\d{1,3}%?\))|(?:#(?:[0-9a-f]{6}|[0-9a-f]{3})))';
		$this->colours = '((?:(?:background-)?color'.$this->colon.')'.$this->colourValues.')';
		$this->decoration = '((?:text-decoration'.$this->colon.')(?:none|underline|overline|line-through|blink))';
		$this->alignment = '((?:(?:position|whitespace|display|clear|float|(?:text|vertical)-align)'.$this->colon.')(?:inherit|relative|static|absolute|normal|pre|nowrap|block|inline|list-item|both|none|left|right|center|justify|baseline|sub|super|top|text-top|middle|bottom|text-bottom|[+-]?\d+%))';
		$this->sizes = '((?:(?:line-height|text-indent|letter-spacing|word-spacing|width|height|top|left|right|bottom|margin(?:-(?:left|right|top|bottom))?|padding(?:-(?:left|right|top|bottom))?)'.$this->colon.')'.$this->units.')';
		$this->fontValues = '(?:'.$this->units.'|serif|arial|["]lucida console["]|[\']lucida console[\']|serif|times|sans-serif|cursive|verdana|fantasy|monospace|normal|oblique|italic|small-caps|bolder|bold|lighter|[xx]{1,2}-small|smaller|small|medium|larger|large|[x]{1,2}-large|[1-9]00)';
		$this->font = '((?:font(?:-family|-style-|-variant|-weight|-size)?)'.$this->colon.$this->fontValues.'(?:[,\s\/]+'.$this->fontValues.')*)';
		$this->backgroundValues = '(?:'.$this->url.'|'.$this->units.'|none|top|center|bottom|left|center|right|scroll|fixed|repeat-x|repeat-y|no-repeat|repeat|'.$this->colourValues.')';
		$this->background = '((?:background(?:-color|-image|-repeat|-attachment|-position)?'.$this->colon.$this->backgroundValues.'(?:[\s]+'.$this->backgroundValues.')*))';
		$this->transform = '((?:text-transform)'.$this->colon.'(?:none|capitalize|uppercase|lowercase))';
		$this->borderValues = '(?:'.$this->units.'|thick|medium|thin|thinnone|dotted|dashed|solid|double|groove|ridge|inset|outset|collapse|separate|inherit|'.$this->colourValues.')';
		$this->border = '((?:border(?:-top|-right|-bottom|-left)(?:-width|-color|-style)?|(?:border(?:-width|-color|-style|-collapse)?))'.$this->colon.$this->borderValues.'(?:[\s]+'.$this->borderValues.')*)';
		$this->listValues = '(?:'.$this->url.'|inside|outside|disc|circle|square|decimal|lower-roman|upper-roman|lower-alpha|upper-alpha|none)';
		$this->list = '((?:list-style(?:-type|-image|-position)?)'.$this->colon.$this->listValues.'(?:[\s]+'.$this->listValues.')*)';
		$this->tableLayout = '((?:table-layout)'.$this->colon.'(?:auto|fixed)*)';
		$this->whiteSpaceValues = '(?:normal|nowrap|pre-wrap|pre-line|pre|inherit)';
		$this->whiteSpace = '((?:white-space)'.$this->colon.$this->whiteSpaceValues.'*)';
		$this->captionSideValues = '(?:top|bottom|inherit)';
		$this->captionSide = '((?:caption-side)'.$this->colon.$this->captionSideValues.'*)';
		$this->mainRegExp = '/'.$this->selectorStart.'|'.$this->selectorEnd.'|'.$this->border.'|'.$this->colours.'|'.$this->sizes.'|'.$this->font.'|'.$this->decoration.'|'.$this->alignment.'|'.$this->background.'|'.$this->transform.'|'.$this->list.'|'.$this->tableLayout.'|'.$this->whiteSpace.'|'.$this->captionSide.'/iu';
	}
	
}

?>